# Interface yii\filters\auth\AuthInterface

Implemented by | yii\filters\auth\AuthMethod, yii\filters\auth\CompositeAuth, yii\filters\auth\HttpBasicAuth, yii\filters\auth\HttpBearerAuth, yii\filters\auth\HttpHeaderAuth, yii\filters\auth\QueryParamAuth
Available since version | 2.0
Source Code | https://github.com/yiisoft/yii2/blob/master/framework/filters/auth/AuthInterface.php

AuthInterface is the interface that should be implemented by auth method classes.

## Public Methods

Hide inherited methods

Method | Description | Defined By
--- | --- | ---
authenticate() | Authenticates the current user. | yii\filters\auth\AuthInterface
challenge() | Generates challenges upon authentication failure. | yii\filters\auth\AuthInterface
handleFailure() | Handles authentication failure. | yii\filters\auth\AuthInterface

## Method Details

authenticate() public abstract method

Authenticates the current user.

public abstract yii\web\IdentityInterface authenticate ( $user, $request, $response )
$user | yii\web\User |
$request | yii\web\Request |
$response | yii\web\Response |
return | yii\web\IdentityInterface | The authenticated user identity. If authentication information is not provided, null will be returned.
throws | yii\web\UnauthorizedHttpException | if authentication information is provided but is invalid.

challenge() public abstract method

Generates challenges upon authentication failure.

For example, some appropriate HTTP headers may be generated.

public abstract void challenge ( $response )
$response | yii\web\Response |

handleFailure() public abstract method

Handles authentication failure.

The implementation should normally throw UnauthorizedHttpException to indicate authentication failure.

public abstract void handleFailure ( $response )
$response | yii\web\Response |
throws | yii\web\UnauthorizedHttpException |